pf: Always skip "urpf-failed" test for IPv6 link local addresses
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 IF_PPP AND PPPD REMOVED
16 -----------------------
17
18 It has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
19 already been removed from our default kernel configuration before 5.0,
20 so only people with custom configurations based on earlier X86_64_GENERIC
21 will have to remove it manually.
22
23 +-----------------------------------------------------------------------+
24 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
25 +-----------------------------------------------------------------------+
26
27 FFS_ROOT OPTION DISABLED
28 ------------------------
29
30 The FFS_ROOT option has been made a no-op and will be completely removed
31 at some point in the future. Users with a custom kernel configuration
32 can remove this option from it now.
33
34 +-----------------------------------------------------------------------+
35 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
36 +-----------------------------------------------------------------------+
37
38 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
39 -----------------------------------------------
40
41 They were all in our X86_64_GENERIC kernel configuration file, along with
42 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
43 configuration files derived from it need adjustment.
44
45 PORTAL FILE SYSTEM REMOVED
46 --------------------------
47
48 It has been broken for a long time now.
49
50 BINUTILS 2.27 REPLACES 2.24, PRIMARY
51 ------------------------------------
52
53 The oldest of the two versions of Binutils, version 2.24, was removed
54 and replaced with Binutils 2.27.  It becomes the primary version version
55 of binutils and version 2.25 becomes the alternate.
56
57 The accepted values of BINUTILSVER are now "binutils227" (default) and
58 "binutils225".  The building of Binutils 2.25 can be prevented by setting
59 NO_ALTBINUTILS=yes in make.conf.
60
61 COMPAT_43 KERNEL OPTION REMOVED
62 -------------------------------
63
64 It was commented out in our default configs for several years now, but
65 might still be present in custom configs created before Nov. 2011.
66
67 OPENSSL REMOVED
68 ---------------
69
70 OpenSSL has been removed from base and replaced with a private version of
71 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
72 pages will remain on the system unless the "make upgrade" command is
73 specifically instructed to remove them.  To do this, define
74 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
75 "make upgrade REMOVE_OPENSSL_FILES=yes"
76
77 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
78 stale OpenSSL files be removed to avoid configuration scripts from using
79 the stale and potentially vulnerable version, but all binaries that are
80 dynamically linked to the OpenSSL libraries should be rebuilt first to
81 avoid breakage.
82
83 OPENSSH HPN REMOVED
84 -------------------
85
86 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
87 To use OpenSSH in base remove HPN config, if you have added it.
88 Check files below for HPN config, see a few lines below.
89   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
90 sshd(8) will fail to start if HPN config is used.
91
92 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
93
94 HPN config:
95 HPNDisabled
96 HPNBufferSize
97 TcpRcvBuf
98 TcpRcvBufPoll
99 NoneEnabled
100 NoneSwitch
101 cipher MTR-AES-CTR
102 cipher NONE
103
104 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
105 circumstances, especially for networking.
106 If HPN functionality is needed, install security/openssh from dports.
107
108 CS, EX AND VX DRIVERS REMOVED
109 -----------------------------
110
111 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
112 old and its doubtful they ever worked properly in x86_64 but they were
113 in X86_64_GENERIC, so custom configurations derived from it have to be
114 adjusted.
115
116 +-----------------------------------------------------------------------+
117 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
118 +-----------------------------------------------------------------------+
119
120 AMD REMOVED
121 -----------
122
123 The am-utils automounter suite has been removed. It stopped working
124 at some point and was never fixed. autofs(5) and the associated
125 userland has been brought in from FreeBSD and replaces it.
126
127 AN DRIVER REMOVED
128 -----------------
129
130 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
131 config file, so any configurations derived from it have to be adjusted.
132
133 /DEV/DRI GROUP CHANGED
134 ----------------------
135
136 The default group assigned to /dev/dri entries has been changed
137 from 'wheel' to 'video' with the id of '44'. If you want to have
138 access to the dri devices please add yourself to the video group
139 with:
140
141 # pw groupmod video -m $USER
142
143 +-----------------------------------------------------------------------+
144 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
145 +-----------------------------------------------------------------------+
146
147 DSCHED REMOVED
148 --------------
149
150 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
151 in our default kernel config file. So the DSCHED_FQ option has been turned
152 into a no-op for now and can be removed from custom configurations.
153
154 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
155 -------------------------------------------------
156
157 The est(4) driver has been removed. All CPUs it supported (except one)
158 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
159 report back if there are any issues with this CPU and our regular ACPI
160 P-state support.
161
162 Also, compile_et(1) and com_err(3) have been removed as well. They
163 should have been removed along with kerberos support, back in 2009.
164
165 SEVERAL LOCALES RENAMED
166 -----------------------
167
168 Several locales were using obsolete and misleading names, and thus have
169 been adjusted to current standards. Any users of the following locales
170 need to select alternates:
171
172 DFLY 4.2 locale            DFLY 4.4 alterative locale
173 ---------------            ------------------------------------
174 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
175 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
176 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
177 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
178 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
179 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
180 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
181 zh_CN.GBK                  zh_Hans_CN.GBK
182 zh_CN.UTF-8                zh_Hans_CN.UTF-8
183 zh_CN.eucCN                zh_Hans_CN.eucCN
184 zh_CN.GB2312               zh_Hans_CH.GB2312
185 zh_CN.GB18030              zh_Hans_CH.GB18030
186 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
187 zh_HK.UTF_8                zh_Hant_HK.UTF-8
188 zh_TW.Big5                 zh_Hant_TW.Big5
189 zh_TW.UTF-8                zh_Hant_TW.UTF-8
190
191 +-----------------------------------------------------------------------+
192 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
193 +-----------------------------------------------------------------------+
194
195 BINUTILS 2.25 REPLACES 2.22, PRIMARY
196 ------------------------------------
197
198 The oldest of the two versions of Binutils, version 2.22, was removed
199 and replaced with Binutils 2.25.  It becomes the primary version version
200 of binutils and version 2.24 becomes the alternate.  There are 8 current
201 CVE written against 2.24, so for security reasons version 2.25 should
202 always be used.
203
204 The accepted values of BINUTILSVER are now "binutils225" (default) and
205 "binutils224".  The building of Binutils 2.24 can be prevented by setting
206 NO_ALTBINUTILS=yes in make.conf.
207
208 LOADER OPTIONS CHANGED
209 ----------------------
210
211 Right after the development branch started, the Fred art accompanying the
212 loader menu was improved.  The line between Fred and the menu was removed
213 by default (but can optionally be returned) and the placement shifted as
214 a result.  The drawing was improved, and the colored version was improved,
215 changing the eyes and wing color from white to red.  A new color version
216 of Fred was added, one with a blue scheme.
217
218 The loader menu defaults have changed since release 4.0:  The vertical
219 line was removed, the loader is displayed in color by default*, and the
220 blue scheme is used.
221
222 The loader.conf changes are:
223 loader_color:   option has been removed
224 loader_plain:   option has been added, it changed menu to monochrome
225 fred_is_red:    changes color scheme from blue to red
226 fred_is_blue:   option existed only on 4.1, it has been removed
227 fred_separated: Adds line between Fred and menu (as seen previously)
228
229 * If loader.conf defines "console" as "comconsole" or "console" is defined
230   in the environment as "comconsole" then color will not be displayed,
231   even if loader_plain value is "NO".
232
233 SENDMAIL REMOVED FROM BASE
234 --------------------------
235
236 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
237 If the system being upgraded is still configured to use the sendmail
238 binaries from base, the "make upgrade" command will fail.
239
240 The administrator must change /etc/mail/mailer.conf to switch the
241 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
242 command that permanently removes sendmail executables and could
243 potentially break a running mail server.
244
245 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
246 detailed instructions on how to configure the MTA selection.
247
248 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
249 --------------------------------------------
250
251 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
252 no-ops. They can be removed from custom kernel configurations.
253
254 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
255 --------------------------------------------
256
257 Many more sound devices may be detected.
258
259 If the default device choosen isn't to your liking, setting the sysctl
260 hw.snd.default_unit to a different number will change it.
261
262 SCTP SUPPORT DROPPED
263 --------------------
264
265 Support for the SCTP protocol has been removed.
266
267 OLD USB DRIVERS REMOVED
268 -----------------------
269
270 The old USB stack, along with the kernel config option "device oldusb"
271 and the make.conf variable "WANT_OLDUSB" have been removed. This means
272 that for custom kernel configuration files which were derived from a
273 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
274 various (old USB stack specific) devices will now complain about being
275 unknown:
276
277   * oldusb      (obviously)
278   * natausb     (not yet ported to usb4bsd)
279   * rue         (not yet ported to usb4bsd)
280   * ugen        (no longer needed in usb4bsd)
281   * urio        (not yet ported to usb4bsd)
282   * uscanner    (no longer needed in usb4bsd)
283
284 They should be removed or commented out in such custom kernel configs.
285
286 GCC 5
287 -----
288
289 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
290 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
291 NO_CXX.  The latter was never documented and the latest versions of GCC are
292 partially written in C++ so a C++ compiler is no longer optional.  In
293 practical terms it has not been optional for many years as other base
294 components are also written in C++.  The resource savings by avoiding
295 building Objective-C compiler is so small, the complexity added by NO_OBJC
296 internally was deemed a bad tradeoff so that is the reason for its removal.
297 Also note that no "info" pages are installed with GCC 5.  After this entry
298 was originally written, all info pages were removed from DragonFly.
299
300 GCC 5.1 has been designated as the primary compiler.  As such, there is a
301 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
302 the designated secondary compiler, GCC 4.7.  However, while DPorts
303 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
304 if building ports from source is desired, don't block building of the
305 secondary compiler.
306
307 +-----------------------------------------------------------------------+
308 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
309 +-----------------------------------------------------------------------+
310
311 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
312 -------------------------------------------
313
314 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
315 the default now (even on single-core systems), both for, like, 21 months.
316 We kept the options around as no-ops as a convenience, to allow people
317 using the same config for the then current release and the then current
318 master. That period is now over, so any configs still having those
319 options have to be adjusted.
320
321 SYSVIPC SYSCALLS MADE NON-OPTIONAL
322 ----------------------------------
323
324 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
325 now compiled in by default. The options are no-ops for now.
326
327 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
328 --------------------------------------------------------------------
329
330 The default driver for those controllers is now mrsas(4) due to reports
331 of file system corruption using the mfi(4) driver. The whole issue (and
332 how to deal with potential problems when switching) was explained here:
333
334 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
335
336 A tunable is provided for letting those controllers still attach via
337 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
338
339 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
340 ----------------------------------------
341
342 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
343 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
344 removed in kernel configs derived from X86_64_GENERIC.
345
346 +-----------------------------------------------------------------------+
347 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
348 +-----------------------------------------------------------------------+
349
350 UPDATE FROM MOST RECENT 3.6
351 ---------------------------
352
353 Versions of 3.6 built before June 25th have a bug where installworld might 
354 crash during installation of the new initrd.  Upgrade to the latest version
355 of 3.6 before updating to 3.8 or later.
356
357 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
358 --------------------------------------
359
360 Support for the IPX and NCP network protocols and for mouting NetWare
361 file systems has been dropped. Dito for ATM protocol support.
362
363 INITRD IMAGES NOW INSTALLED BY DEFAULT
364 --------------------------------------
365
366 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
367
368 Older images installed under the file name of initrd.img will be removed
369 automatically by the make upgrade process.
370
371 USB4BSD IS NOW THE DEFAULT USB STACK
372 ------------------------------------
373
374 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
375 replace "device usb" with "device oldusb" in the kernel configuration.
376
377 MORE ISA SUPPORT DROPPED
378 ------------------------
379
380 ISA support has been dropped from the following drivers: adv(4), an(4),
381 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
382 si(4), sn(4), and stg(4).
383
384 +-----------------------------------------------------------------------+
385 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
386 +-----------------------------------------------------------------------+
387
388 ABI CHANGE
389 ----------
390
391 Installed third-party software (dports) will have to be rebuilt after upgrade,
392 or reinstalled from binary packages.
393
394 UPDATING FROM 3.4 TO 3.6
395 ------------------------
396
397 This only applies for this specific upgrade due to locale changes; it is 
398 not needed for upgrades after 3.6.  Please update in this order:
399
400 make buildworld
401 make buildkernel
402 make installworld
403 make installkernel
404 *reboot*
405 make upgrade
406
407 See this mailing list post for details:
408 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
409
410 CYRIX OPTIONS REMOVED
411 ---------------------
412
413 The following Cyrix related options have been removed: CPU_BTB_EN,
414 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
415 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
416 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
417
418 ISA SUPPORT REMOVED FROM RP(4)
419 ------------------------------
420
421 ISA support has been removed from the rp(4) driver. It is now PCI only.
422
423 +-----------------------------------------------------------------------+
424 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
425 +-----------------------------------------------------------------------+
426
427 COMPAT_SUNOS OPTION REMOVED
428 ---------------------------
429
430 The COMPAT_SUNOS option has been removed. It was meant to provide binary
431 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
432
433 ISA SOUND CARD SUPPORT REMOVED
434 ------------------------------
435
436 The following modules have been removed (all for ISA sound cards):
437 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
438
439 GCC 4.7
440 -------
441
442 DragonFly has switched base compilers.  GCC 4.7 is now the default
443 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
444 variable ceases to work now.
445
446 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
447 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
448 highly discouraged.  There are a few packages in pkgsrc that do not build
449 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
450 this time, it is recommended to keep both compilers on the base system.
451
452 SMP OPTION REMOVED
453 ------------------
454
455 The SMP kernel option has been made a no-op. All kernels now feature SMP
456 support. If you have 'options SMP' in your kernel config, you can as well
457 remove it.
458
459 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
460 ---------------------------------------------------------------------------
461
462 The DEVICE_POLLING kernel option has been made a no-op and it has been
463 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
464 kernel config, you need to change it to IFPOLL_ENABLE.
465
466 Also, the KTR_POLLING kernel option has been removed, so it must be
467 removed from kernel configs that have it.
468
469 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
470 ---------------------------------------------------
471
472 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
473 cards will no longer be detected.
474
475 The same has been done for Stallion multiport serial controllers. stli(4)
476 has been completely removed (along with the stlload(8) and stlstty(8)
477 utilities) and stl(4) was changed to support only PCI cards. Similarly,
478 ISA support was removed from cy(4) too. All these drivers are i386 only.
479
480 COMPAT_OLDISA OPTION GONE
481 -------------------------
482
483 The i386 specific COMPAT_OLDISA kernel option has been removed, since
484 nothing needs it anymore.
485
486 +-----------------------------------------------------------------------+
487 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
488 +-----------------------------------------------------------------------+
489
490 APIC_IO OPTION REMOVED
491 ----------------------
492
493 The APIC_IO kernel option is no longer accepted after having been without
494 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
495 If you have 'options APIC_IO' in your kernel config, you'll have to
496 remove it.
497
498 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
499 -----------------------------------------
500
501 The wdog framework is now compiled into our kernels by default, so the
502 options are no longer needed.
503
504 DOSCMD(1) REMOVED
505 -----------------
506
507 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
508 NO_X make.conf option was removed too.
509
510 GCC 4.7
511 -------
512
513 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
514 default compiler in base (default is still GCC 4.4).
515
516 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
517 NO_GCC47 in /etc/make.conf.
518
519 USB4BSD
520 -------
521
522 A new USB stack (from FreeBSD) has been brought in. The following
523 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
524 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
525 and uaudio.
526
527 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
528 be put in make.conf and device "usb4bsd" (quotes needed) has to
529 replace device usb in the kernel config. After that, a full
530 build/install/upgrade cycle is needed.
531
532 Note that this is experimental and incomplete, but we are interested
533 in hearing about issues with it, of course.
534
535 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
536 ---------------------------------------------
537
538 ISA adapter support was dropped from the aic(4) driver.
539
540 +-----------------------------------------------------------------------+
541 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
542 +-----------------------------------------------------------------------+
543
544 SEVERAL ISA DRIVERS REMOVED
545 ---------------------------
546
547 The following ISA only drivers have been removed along with a couple of
548 associated userland tools:
549
550 aha(4)
551 asc(4) & sasc(1)
552 ctx
553 dgb(4)
554 el(4)
555 gpib
556 gsc(4) & sgsc(1)
557 ie(4)
558 labpc(4)
559 le(4)
560 mse(4)
561 rc(4)
562 rdp(4)
563 spigot
564 tw(4) & xten(1) & xtend(8)
565 wl(4) & wlconfig(8)
566 wt(4)
567
568 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
569 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
570 file.
571
572 If buildkernel complains about any of these drivers, just remove them
573 from your kernel configuration.
574
575 BINUTILS 2.20
576 -------------
577 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
578 values of BINUTILSVERS are now binutils221 and binutils222 (default).
579
580 BUILDWORLD/-KERNEL PARALLELIZATION WORK
581 ---------------------------------------
582 Due to changes in the way we build with more than one make job, you
583 will have to update install(1) and mkdir(1) prior to buildworld if you
584 want to build with 'make -j':
585
586 cd /usr/src/usr.bin/xinstall; make; make install; make clean
587 cd /usr/src/bin/mkdir; make; make install; make clean
588
589 DMA(8) UPGRADE
590 --------------
591 dma(8) has been upgraded to v0.7 which no longer supports the
592 /etc/dma/virtusertable. Some of its functionality has been replaced
593 with the MASQUERADE keyword and the EMAIL environment variable (see
594 the dma(8) manual page).
595
596 +-----------------------------------------------------------------------+
597 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
598 +-----------------------------------------------------------------------+
599
600 GCC 4.4 & BINUTILS 2.21
601 -----------------------
602
603 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
604 been made DragonFly's default Binutils.
605
606 That means that any settings that set CCVER to 'gcc44' are not needed
607 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
608 GCC 4.1.
609
610 It also means that 'binutils221' as a value for BINUTILSVER has no
611 effect anymore. 2.17 has been removed and 'binutils220' is available
612 as an option.
613
614 The NO_GCC44 option has been removed and will not affect the build
615 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
616 building in a similar fashion.
617
618 Note that you must do a full buildworld/buildkernel for upgrading.
619
620 pkg_radd settings
621 -----------------
622
623 The config file for pkg_radd has moved from /etc/settings.conf to 
624 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
625 if this is needed.  This warning only applies if /etc/settings.conf 
626 exists.  pkg_radd will continue to work with defaults.
627
628 +-----------------------------------------------------------------------+
629 +         20100927                                                      +
630 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
631 +-----------------------------------------------------------------------+
632
633 OpenSSL
634 --------
635
636 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
637 This shouldn't break any 3rd-party software, but you'll need to recompile your
638 3rd-party software if you want it to link against the new version of OpenSSL.
639
640 Loader
641 -------
642
643 A new loader (dloader) has been added which better handles booting from
644 multiple kernel/module versions.
645
646 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
647
648         cd /usr/src
649         make buildworld
650         make installworld
651         make upgrade
652         make buildkernel KERNCONF=<KERNELNAME>
653         make installkernel KERNCONF=<KERNELNAME>
654
655 Note that you must installworld and run the 'upgrade' target before
656 installing the new kernel.
657
658 BIND
659 -----
660
661 BIND has been removed from the base system.  The ldns and drill tools have 
662 been added for basic functionality.  Use 'drill' where you would normally 
663 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
664 net/bind95, net/bind96, or net/bind97 as of this writing.
665
666 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
667 include BIND as a pkgsrc package.
668
669 +-----------------------------------------------------------------------+
670 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
671 +                               GENERAL                                 +
672 +-----------------------------------------------------------------------+
673
674 Instructions on how to obtain and maintain DragonFly source code using git
675 are in the development(7) manual page.
676
677 To upgrade a DragonFly system from sources you run the following sequence:
678
679         cd /usr/src
680         make buildworld
681         make buildkernel KERNCONF=<KERNELNAME>
682         make installkernel KERNCONF=<KERNELNAME>
683         make installworld
684
685 You will also want to run the 'upgrade' target to upgrade your /etc and the
686 rest of your system.  The upgrade target is aware of stale files created by
687 older DragonFly installations and should delete them automatically.
688
689         make upgrade
690
691 See the build(7) manual page for further information.
692
693 Once you've done a full build of the world and kernel you can do incremental
694 upgrades of either by using the 'quickworld' and 'quickkernel' targets
695 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
696 the quick targets, try updating your repo first, and then a full buildworld
697 and buildkernel as shown above, before asking for help.
698
699 +-----------------------------------------------------------------------+
700 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
701 +-----------------------------------------------------------------------+
702
703 In 2.1 kernel and modules has moved to boot directory.  For most cases
704 this is handled automatically by 'make upgrade'.  A few cases needs manual
705 intervention:
706
707  * When installing a kernel without first doing a make buildworld,
708    installworld and upgrade to the same DESTDIR as kernel:
709    make DESTDIR/boot directory and move kernel and modules into this boot
710    directory; also move kernel.old and modules.old.
711    Typical example is vkernel(7), use (no modules used):
712
713         cd /var/vkernel
714         mkdir boot
715         chflags noschg kernel
716         mv kernel kernel.old boot
717         chflags schg boot/kernel
718         
719  * When using a boot-only partition, /boot/loader.rc needs to be edited:
720    delete occurrences of '/boot/'.
721    These occurences can normally be deleted in any case, see loader(8).
722
723 +-----------------------------------------------------------------------+
724 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
725 +-----------------------------------------------------------------------+
726
727 In 1.9 major changes to the disk management infrastructure have taken
728 place.  make upgrade may not catch all of your disk devices in /dev,
729 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
730 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
731 and MAKEDEV no longer exists.
732
733 The biggest changes in 1.9 are:
734
735 (1) That whole-slice devices such as da0s1 no longer share the same device
736     id as partition c devices such as da0s1c.
737
738 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
739     with no snooping or reserved sectors.  Consequently you cannot run
740     disklabel on this device.  Instead you must run disklabel on a
741     whole-slice device.
742
743 (3) The 'compatibility' partitions now use slice 0 in the device name,
744     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
745     accessing the disklabel for the compatibility partitions must be
746     done via slice 0 (da0s0).
747
748 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
749     and CCD now run through the disk management layer and are assigned
750     real disk management devices.   VN and CCD in particular do not usually
751     use a MBR and disklabels must be accessed through the compatibility
752     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
753     don't name it 'ccd0s0' in the config file.
754
755 Generally speaking, you have to get used to running fdisk and disklabel on
756 the correctly specified device names.  A lot of the wiggle, such as running
757 disklabel on a partition, has been removed.
758
759 +-----------------------------------------------------------------------+
760 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
761 +-----------------------------------------------------------------------+
762
763 > Kerberos IV
764 -------------
765
766 Kerberos IV (eBones) was removed from the tree, please consider moving to
767 Kerberos 5 (Heimdal).
768
769 > Package Management System
770 ---------------------------
771
772 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
773 management system.  The necessary tools to build and maintain packages
774 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
775 directories are in your PATH variable.
776
777 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
778 the tarball from NetBSD:
779
780         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
781         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
782
783 This tree can then be kept up to date with cvs update:
784
785         cd /usr/pkgsrc; cvs up
786
787 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
788 build and install the pkgsrc bootstrap manually:
789
790         cd /usr/pkgsrc/bootstrap
791         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
792
793 +-----------------------------------------------------------------------+
794 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
795 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
796 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
797 +-----------------------------------------------------------------------+
798
799 The compatibility shims for the build environment have been removed, you
800 have to update to DragonFly 1.2 release branch first.
801
802 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
803 The existing configuration can be converted using /etc/pam.d/convert.sh.
804 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
805 the pam_skey.so module was retired, you have to remove it manually from
806 your configuration, when you convert it.
807
808 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
809 ---------------------
810
811 The following users may be missing from your password file.  Use vipw and
812 add any that are missing:
813
814 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
815 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
816
817 The following groups may be missing from your group file.  Use vi /etc/group
818 and add any that are missing:
819
820 smmsp:*:25:
821 authpf:*:63:
822 _pflogd:*:64:
823
824
825 > Upgrading to DragonFly from FreeBSD
826 ---------------------
827
828 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
829 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
830 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
831 make depend information, it starts from scratch, so no pre-cleaning of the
832 object hierarchy is necessary.
833
834         # get the CVS repository (it is placed in /home/dcvs, 500MB).
835         # Please use the -h option and a mirror site to pull the 
836         # initial repository, but feel free to use the main repository
837         # machine to pull updates.
838         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
839         # install the source from the CVS hierarchy (remove preexisting
840         # FreeBSD src first) (500MB)
841         cd /usr
842         rm -rf src
843         cvs -R -d /home/dcvs checkout -P src
844
845         # build it (500MB used in /usr/obj)
846         #
847         cd /usr/src
848         make buildworld
849         make buildkernel KERNCONF=<KERNELNAME>
850
851 Once you have built DragonFly you have to install it over FreeBSD.  Since
852 DragonFly does not track changes made by FreeBSD to its include file 
853 hierarchy and include file pollution can cause all sorts of unexpected
854 compilation issues to come up, it is best to wipe your include hierarchy
855 prior to installing DragonFly.  Note that you should not wipe any installed
856 FreeBSD header files or binaries until after you have successfully completed
857 the build steps above.
858
859         rm -rf /usr/include
860         mkdir /usr/include
861         make installkernel KERNCONF=<KERNELNAME>
862         make installworld
863
864 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
865 will unconditionally upgrade the /etc files that sysops do not usually
866 mess around with, such as the files in /etc/rc.d.  It will also remove any
867 obsolete files such as utilities and manpages that have been removed from
868 the system since the version you're coming from.  If you are unsure we 
869 recommend that you make a backup of at least your /etc before applying
870 this step.  Note that DragonFly's RC system is basically RCNG from
871 FreeBSD-5, but there are some differences in the contents of the RC files.
872
873         make upgrade
874
875 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
876 Doing so might leave your system in an unusable state.
877
878 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
879 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
880 report these files to the DragonFly developers so that they can be added to
881 the 'upgrade' target.
882